#!/bin/bash

#if [[ "$EUID" -ne 0 ]]; then
#	echo -e "Sorry, you need to run this as root"
#	exit 1
#fi

BASE_DIR="$(cd "$(dirname "$0")"; pwd)";

# Variables
SVR_INSTALL_USER=`whoami`
APACHE_INSTALL_DIR=$1
SVR_INSTALL_DIR=$2
DOCUMENT_ROOT=$3
HTTP_PORT=$4
SSL_PORT=$5

SOURCE_DIR=${BASE_DIR}/source_files

INSTALL_DATE=`date +%Y%m%d_%H%M%S`

if [ "x$1" = "x" ]; then
    echo "#################################################"
    echo "[WARN] Empty Apache Home directory. Use default value." >> instance_install.log.$INSTALL_DATE
    echo "[WARN] Empty Apache Home directory. Use default value."
    echo "#################################################"

    exit 1;
fi

if [ "x$2" = "x" ]; then
    echo "#################################################"
    echo "[WARN] Empty input install directory. Use default value." >> instance_install.log.$INSTALL_DATE
    echo "[WARN] Empty input install directory. Use default value."
    echo "#################################################"

    SVR_INSTALL_DIR="/opt/WASup/servers/apache-svr-2.4"
    echo "[ SVR_INSTALL_DIR ] is $SVR_INSTALL_DIR"
fi

if [ "x$3" = "x" ]; then
    DOCUMENT_ROOT=$SVR_INSTALL_DIR/htdocs
fi

if [ "x$4" = "x" ]; then
    HTTP_PORT=80
fi

if [ "x$5" = "x" ]; then
    SSL_PORT=443
fi

clear


# Cleanup
# The directory should be deleted at the end of the script, but in case it fails
#rm -r /usr/local/src/apache/ >> /dev/null 2>&1
#mkdir -p ${SVR_INSTALL_DIR}/modules
#mkdir -p ${SVR_INSTALL_DIR}/tmp/client
#mkdir -p ${SVR_INSTALL_DIR}/tmp/proxy
#mkdir -p ${SVR_INSTALL_DIR}/tmp/fastcgi

mkdir -p ${SVR_INSTALL_DIR}
mkdir -p ${SVR_INSTALL_DIR}/bin
mkdir -p ${SVR_INSTALL_DIR}/conf
mkdir -p ${SVR_INSTALL_DIR}/logs

echo "BASE_DIR=$BASE_DIR"
echo "SOURCE_DIR=$SOURCE_DIR"
echo "APACHE_INSTALL_DIR=$APACHE_INSTALL_DIR"
echo "SVR_INSTALL_DIR=$SVR_INSTALL_DIR"
echo "DOCUMENT_ROOT=$DOCUMENT_ROOT"
echo "HTTP_PORT=$HTTP_PORT"
echo "SSL_PORT=$SSL_PORT"


############ Default Template Copy ##############
cp -fR $SOURCE_DIR/bin/* ${SVR_INSTALL_DIR}/bin/
cp -fR $SOURCE_DIR/conf/* ${SVR_INSTALL_DIR}/conf/

if [ ! -d $DOCUMENT_ROOT ] ; then
    mkdir -p $DOCUMENT_ROOT

    if [ -f $APACHE_INSTALL_DIR/htdocs/index.html ] ; then
        cp $APACHE_INSTALL_DIR/htdocs/index.html $DOCUMENT_ROOT/
    fi
fi

############ Apahce HTTPD Server Directory Replace ########
sh ${BASE_DIR}/replace.sh ${APACHE_INSTALL_DIR} ${SVR_INSTALL_DIR} ${DOCUMENT_ROOT} ${HTTP_PORT} ${SSL_PORT}
############ Apahce HTTPD Server Directory Replace ########
